--$Name: City Of Mists$
--$Name(ru): Город Туманов
--$Version:0.0.2$
instead_version '1.7.0'

require 'para'
require 'hideinv'
require 'theme'
require 'timer'
require 'xact'
require 'click'
require 'kbd'
-- require 'dbg'

hook_keys ('space', 'return');
click.bg = true;

dofile ('util.lua');
dofile ('mplayer.lua');

game.act = 'Не получается.';
game.inv = 'Гхм… Странная штука…';
game.use = 'Не сработает…';

global
{
    track_time = 0;

    gold_square = false;
    silver_circle = false;
    silver_rectangle = false;
    copper_triangle = false;

    gold_circle = false;
    silver_triangle = false;
    copper_circle = false;
    gold_triangle = false;

    silver_square = false;
    gold_rectangle = false;
    copper_rectangle = false;
    copper_square = false;

    imprisoned = 0;
    key_visible = false;
    key_visible_before = false;
    key_takable = false;
    tried_take = false;

    ritual_error = false;
    ritual_finished = false;
};


main = room
{
    nam = 'main',
    disp = true,
    click = function(s)
        walk 'main_menu'
    end;
    kbd = function(s)
        s:click();
    end;
    enter = function (s, from)
        theme.set('scr.gfx.bg', 'images/loading.jpg');
        set_music ('music/houl.ogg', 1);
    end,
    exit = function (s, to)
        theme.reset('scr.gfx.bg');
    end,
};


main_menu = room
{
    nam = 'main menu',
    disp = function (s)
        return img ('images/title.png');
    end,
    pic = 'images/intro.jpg',
    enter = function (s, from)
        set_music ('music/intro.ogg');
    end,
    dsc = function (s)
        p [[Автор игры: werewolf (werewolf999@rambler.ru)^
        Игра написана для QSP-Compo 2011: Фейерверк чудес^
        Внимание: В данной игре предметами из инвентаря можно действовать
        только на объекты сцены. Соединение предметов в инвентаре
        невозможно.^^
        Адаптация для INSTEAD – Вадим В. Балашов (v.v.b.),
        vvb.backup@rambler.ru^
        Версия 0.0.2 (30.11.2014).
        ]];
        return;
    end,
    obj =
    {
        vway('1', '{Начать игру}^', 'intro'),
    },
};


intro = room
{
    nam = '…',
    hideinv = true,
    dsc = function (s)
        p [[Уже более ста лет прошло с того дня, когда Лендал стал Городом
        туманов. Никто уже не знает, что было причиной этому проклятию.
        Говорят, что туман в Лендале может выпить душу. Может и так… Никто
        ещё не вернулся оттуда, чтобы опровергнуть эти слухи.^
        Наверное, Лендал так и остался бы для тебя страшной легендой, если бы
        однажды, перебрав вина, ты не заявил, что все эти туманы полная ерунда
        и тебе ничего не стоит снять это проклятие. Это могло остаться просто
        словами, но в запале ты поклялся перед богами пойти в Лендал и снять
        проклятие. Теперь ничего не остаётся, как отправиться туда – смерть
        клятвопреступников никогда не была лёгкой, а так можно ещё
        побарахтаться.
        ]];
    end,
    obj =
    {
        vway('1', '{Далее}', 'city_square'),
    };
    exit = function (s, to)
        stop_music ();
    end,
};


city_square = room
{
    nam = 'Городская площадь',
    _visited = false,
--    enter = function (s, from)
--        set_music ('music/fon_1.ogg');
--    end,
    dsc = function (s)
        if not s._visited then
            s._visited = true;
            p [[Густой туман окутывает улицы города. Почти все дома обветшали
            от старости и готовы развалиться просто от прикосновения или
            громкого звука. Воздух в городе неподвижен и туман настолько
            приглушает все звуки, что даже звук твоих шагов едва слышен.^
            Вскоре ты выходишь на главную площадь города.
            ]];
        end
        p [[Несколько зданий на площади не в таком плохом состоянии как
        другие.^
        За невысокой стеной с металлическими воротами видна старая церковь.
        Недалеко от неё возвышается огромное здание гильдии магов.^
        Из всех домов, выходящих на площадь, неплохо сохранились богатый
        особняк и коттедж. В конце улицы, отходящей от площади, видна
        небольшая уцелевшая хижина.
        ]];
    end,
    way =
    {
        vroom ('Церковь', 'church_front'),
        vroom ('Гильдия Магов', 'mages_tower_front'),
        vroom ('Особняк', 'mansion'),
        vroom ('Коттедж', 'mages_hall'),
        vroom ('Хижина', 'dream_room'),
    },
};


church_front = room
{
    nam = 'Перед церковью',
    dsc = function (s)
        p [[Старая церковь с высокими готическими шпилями возвышается в
        небольшом дворике. Через слегка приоткрытые заржавевшие ворота виден
        заросший сад. Серые тусклые лица проплывают в тумане так быстро, что
        ты видишь их только уголком глаза.
        ]];
    end,
    way =
    {
        vroom ('В церковь', 'church'),
        vroom ('Сад', 'church_garden'),
        vroom ('Площадь', 'city_square'),
    },
};


church_garden = room
{
    nam = 'Сад',
    dsc = function (s)
        p [[Каменные статуи людей, затянутых в монашеские робы,
        возвышаются среди древесной листвы, а виноградные плети опутывают
        их ноги. Идеально белые, молчаливые коты тихо ступают по сухим
        листьям, скользя их ниоткуда в никуда. Кажется, что они следуют за
        вами, то пропадая в тумане, то вновь пристально поглядывая на вас
        с вершины изгороди.^
        В тумане даже листья кажутся мёртвыми, и только лёгкий ветер тихо
        шелестит ими у тебя над головой.
        ]];
    end,
    obj =
    {
        'fountain',
    };
    way =
    {
        vroom ('К церкви', 'church_front'),
    },
};


fountain = obj
{
    nam = 'фонтан',
    dsc = function (s)
        p [[В самом центре сада находится высохший {фонтан}.
        ]];
    end,
    act = function (s)
        p [[Высохший фонтан заполнен сухими листьями.
        ]];
    end,
    obj =
    {
        'leaves',
    },
};


leaves = obj
{
    nam = 'листья',
    _burning = false,
    dsc = function (s)
        if not seen (bowl) then
            if not leaves._burning then
                p [[Сухие {листья} заполняют высохший фонтан.
                ]];
            else
                p [[В высохшем фонтане тихо тлеют сухие {листья}.
                ]];
            end
        else
            if not leaves._burning then
                p [[На сухих {листьях}, заполняющих фонтан,
                ]];
            else
                p [[На тлеющих {листьях}, заполняющих фонтан,
                ]];
            end
        end
    end,
    act = function (s)
        if not s._burning then
            p [[Несмотря на влажный туман, висящий в воздухе, листья остаются
            сухими.
            ]];
        else
            p [[В высохшем фонтане тихо тлеют сухие листья.
            ]];
        end
    end,
};


church = room
{
    nam = 'Церковь',
    dsc = function (s)
        p [[Чем ближе ты подходишь к церкви, тем сильнее становится неясный
        шёпот, как бы отражаясь от окружающих стен. Древние каменные двери,
        которые ведут в церковь, распахнуты настежь, а сухие листья усеивают
        весь пол. Воздух в здании кажется холоднее, чем снаружи.
        ]];
    end,
    obj =
    {
        'church_bench',
        'church_window',
    },
    way =
    {
        vroom ('В подсобку', 'church_store_room'),
        vroom ('К алтарю', 'church_altar'),
        vroom ('Выйти из церкви', 'church_front'),
    },
};


church_bench = obj
{
    nam = 'скамья',
    dsc = function (s)
        p [[Огромный зал церкви заставлен {деревянными скамьями}, формирующими
        проход к алтарю. Тяжёлые тени скрывают высокие потолки, придавая
        комнате вид склепа.
        ]];
    end,
    act = function (s)
        p [[Хотя скамьи ещё сохраняют форму, но дерево уже настолько
        трухлявое, что стоит их коснуться, как они рассыпаются на части.
        ]];
    end,
};


church_window = obj
{
    nam = 'витраж',
    dsc = function (s)
        p [[Огромное {узорчатое окно} за алтарём занимает большую часть стены.
        Три ступени из холодного чёрного камня ведут к алтарному возвышению.
        Высокие узкие окна разбросаны по всей церкви, но через них видны
        только затянутые туманом деревья. Небольшая дверца в дальнем углу
        ведёт в подсобку.
        ]];
    end,
    act = function (s)
        p [[На витраже изображена ведьма в чёрных лохмотьях и с искажённым
        злобой лицом в окружении полустёртых фигур ангелов и святых.
        ]];
        local t = math.random (3);
        if t == 3 then
            p [[В тумане становятся видны странные серые фигуры. Они
            напоминают бледных детей, проходящих странным строем перед этим
            окном. Но через несколько минут они растворяются в тумане.
            ]];
        end
    end,
};


church_store_room = room
{
    nam = 'Подсобка',
    enter = function (s, from)
        girl._seen = true;
        magician_dlg:pon ('others');
    end,
    dsc = function (s)
        if not seen (candlestick) then
            p [[Пустые деревянные полки у стен затянуты паутиной.
            ]];
        end
    end,
    obj =
    {
        'candlestick',
        'girl',
    },
    way =
    {
        vroom ('Выйти', 'church'),
    },
};


girl = obj
{
    nam = 'девочка',
    _seen = false,
    _dispelled = false,
    dsc = function (s)
        p [[В углу сидит маленькая {девочка}, одетая в белую кружевную
        рубашку.
        ]];
    end,
    act = function (s)
        p [[«Мари, моя Мари… Она забрала мою Мари…» – постоянно повторяет
        девочка сквозь всхлипывания. Тебя она, похоже, не слышит, и когда ты
        пытаешь её коснуться, рука проходит насквозь.
        ]];
    end,
};


church_altar = room
{
    nam = 'Церковь. Алтарь',
    obj =
    {
        'altar',
    },
    way =
    {
        vroom ('Отойти от алтаря', 'church'),
    },
};


altar = obj
{
    nam = 'алтарь',
    _moved = false,
    dsc = function (s)
        if s._moved then
            p [[Отодвинутый в сторону {алтарь} открывает проём в полу с
            каменными ступенями, ведущими во тьму.
            ]];
        else
            p [[Перед тобой стоит {алтарь}.
            ]];
        end
    end,
    obj =
    {
        'altar_lacuna',
    },
    act = function (s)
        p [[Массивный постамент из чёрного камня. Пол возле него сильно
        поцарапан, как будто алтарь передвигали.
        ]];
    end,
    check_restore = function (s)
        if s._moved then
            s._moved = false;
            ways (curch_altar):del ('Спуститься в проём');
            p [[Как только ты забираешь свечу, алтарь с тихим шорохом
            становится на место.
            ]];
        end
    end,
};


altar_lacuna = obj
{
    nam = 'углубление',
    dsc = function (s)
        if not seen (candlestick) then
--            p [[В центре возвышения есть небольшое треугольное {углубление}.
            p [[В центре возвышения есть {углубление}.
            ]];
        end
    end,
    act = function (s)
        p [[Небольшое углубление треугольной формы.
        ]];
    end,
};


mages_tower_front = room
{
    nam = 'Перед Башней магов',
    _can_enter_tower = false,
    dsc = function (s)
        p [[Огромное здание из белого камня тянется к небу своими башнями.
        Их очертания постепенно растворяются в тумане, так что невозможно
        понять насколько они высоки на самом деле.
        ]];
        if not s._can_enter_tower then
            p [[Но подойти к зданию не получается – невидимая стена
            преграждает путь.
            ]];
        end
    end,
    way =
    {
        vroom ('Площадь', 'city_square'),
        vroom ('Войти в башню', 'mages_tower_1'),
    },
    exit = function (s, to)
        if to == mages_tower_1 and not s._can_enter_tower then
            p [[Подойти к зданию не получается – невидимая стена преграждает
            путь.
            ]];
            return false;
        end
    end,
};


mages_tower_1 = room
{
    nam = 'Башня магов. Этаж 1',
    dsc = function (s)
        p [[Небольшая комната в основании башни. Круглая лестница
        позволяет подняться на следующий этаж. На приоткрытой двери возле
        лестницы нарисован знак бесконечности.
        ]];
    end,
    way =
    {
        vroom ('В дверь', 'mages_tower_mirror_room'),
        vroom ('Подняться по лестнице', 'mages_tower_2'),
        vroom ('Выйти из башни', 'mages_tower_front'),
    },
};


mages_tower_mirror_room = room
{
    nam = 'Башня магов. Зеркальная комната',
    dsc = function (s)
        p [[В небольшой комнате нет никакой мебели кроме двух зеркал на
        противоположных стенах.
        ]];
    end,
    obj =
    {
        'mirror_left',
        'mirror_right',
        'key_copper',
    },
    way =
    {
        vroom ('Выйти', 'mages_tower_1'),
    },
};


mirror_left = obj
{
    nam = 'левое зеркало',
    _covered = false,
    dsc = function (s)
        p 'Слева стоит {зеркало} в резной деревянной оправе.';
    end,
    act = function (s)
        if not have (key_copper) and book_door._copper_lock and mirror_right._covered then
            key_copper:enable();
            p 'В зеркале отражается ключ, висящий в центре комнаты.';
            return;
        end
        if s._covered then
            p 'Левое зеркало завешено чехлом.';
        else
            p 'Ты смотришь в левое зеркало. Ничего особенного.';
        end
    end,
};


mirror_right = obj
{
    nam = 'правое зеркало',
    _covered = false,
    dsc = function (s)
        p 'Справа стоит {зеркало} в резной деревянной оправе.';
    end,
    act = function (s)
        if s._covered then
            p 'Правое зеркало завешено чехлом.';
        else
            p 'Ты смотришь в правое зеркало. Ничего особенного.';
        end
    end,
};


key_copper = obj
{
    nam = 'медный ключ',
    dsc = 'В центре комнаты в воздухе висит {ключ}.',
    inv = 'Массивный медный ключ.',
    tak = 'Ты берёшь медный ключ.',
    use = function (s, w)
        if w == book_door then
            drop (s);
            s:disable();
            book_door._copper_lock = false;
            p [[Как только ты поворачиваешь ключ в замке, медный замок
            исчезает.
            ]];
        end
    end,
}:disable();


mages_tower_2 = room
{
    nam = 'Башня магов. Этаж 2',
    dsc = function (s)
        p [[Небольшая площадка на круглой лестнице. На закрытой двери,
        выходящей на неё, нарисован небольшой куб.
        ]];
    end,
    way =
    {
        vroom ('Спуститься по лестнице', 'mages_tower_1'),
        vroom ('В дверь', 'mages_tower_crystal_room'),
        vroom ('Подняться по лестнице', 'mages_tower_3'),
    },
};


mages_tower_crystal_room = room
{
    nam = 'Башня магов. Кристальная комната',
    obj =
    {
        'cube',
        'key_silver',
    },
    way =
    {
        vroom ('Выйти', 'mages_tower_2'),
    },
};


cube = obj
{
    nam = 'куб',
    _whole = true,
    dsc = function (s)
        if s._whole then
            p [[В центр этой комнаты помещён огромный кристаллический
            прозрачный {куб}.
            ]];
        else
            p [[Осколки кристаллического куба отбрасывают блики на стены
            комнаты.
            ]];
        end
    end,
    act = 'Огромный куб сделан из прозрачного кристалла.',
};


key_silver = obj
{
    nam = 'серебряный ключ',
    dsc = function (s)
        if cube._whole then
            p [[Сквозь стенки ты замечаешь {серебряный ключ}, плавающий в
            центре куба.
            ]];
        else
            p [[Среди них {серебряный ключ} едва заметен.
            ]];
        end
    end,
    tak = function (s)
        if cube._whole then
            p 'Не получается. Ключ находится внутри кристалла.';
            return false;
        else
            p 'Ты берёшь серебряный ключ.';
        end
    end,
    use = function (s, w)
        if w == book_door then
            drop (s);
            s:disable();
            book_door._silver_lock = false;
            p [[Как только ты поворачиваешь ключ в замке, серебряный замок
            исчезает.
            ]];
        end
    end,
};


mages_tower_3 = room
{
    nam = 'Башня магов. Этаж 3',
    dsc = function (s)
        p [[Небольшая площадка на круглой лестнице. На закрытой двери,
        выходящей на неё, нарисованы квадрат, треугольник, круг и
        прямоугольник.
        ]];
    end,
    way =
    {
        vroom ('Спуститься по лестнице', 'mages_tower_2'),
        vroom ('В дверь', 'mages_tower_figures_room'),
        vroom ('Подняться по лестнице', 'mages_tower_4'),
    },
};


mages_tower_figures_room = room
{
    nam = 'Башня магов. Комната с фигурами',
    obj =
    {
        'table',
        'skeleton',
        'parchment'
    },
    way =
    {
        vroom ('Выйти', 'mages_tower_3'),
    },
};


table = obj
{
    nam = 'столик',
    dsc = 'Возле дальней стены стоит невысокий {столик}.',
    act = function (s)
        if not figures_puzzle_room._key_taken then
            walk (figures_puzzle_room);
        else
            p [[Ты уже получил золотой ключ.
            ]];
        end
    end,
};


skeleton = obj
{
    nam = 'скелет',
    dsc = function (s)
        p [[Перед столиком лежит {скелет} в полуистлевшей одежде.
        ]];
    end,
    act = function (s)
        p [[Судя по одежде, при жизни это был небогатый мужчина. Наверное, это
        один из авантюристов, искавших счастья в Городе туманов.
        ]];
        if not have (parchment) then
            parchment:enable();
            p 'В его руке ты замечаешь небольшой листок пергамента.';
        end
    end,
};


parchment = obj
{
    nam = 'пергамент',
    dsc = function (s)
        p [[В руке скелета зажат небольшой листок {пергамента}.
        ]];
    end,
    inv = function (s)
        walk (parchment_read);
    end,
    tak = 'Ты берёшь листок пергамента.',
}:disable();


parchment_read = room
{
    nam = true,
    hideinv = true,
    pic = 'images/parchment.jpg',
    dsc = function (s)
        p [[Небольшой листок пергамента, исписанный неровным почерком:^^
        Прикосновение зажигает фигуру, прикосновение же её гасит.^
        ^
        <b>Золотой квадрат</b> – круги не действуют, когда не светится^
        <b>Золотой прямоугольник</b> – ?^
        <b>Золотой треугольник</b> – если не светится, не действуют квадраты,
        если светится – прямоугольники^
        <b>Золотой круг</b> – когда не светится, гасит все фигуры в том же
        ряду^
        ^
        <b>Серебряный квадрат</b> – если не светится, виден призрачный ключ^
        <b>Серебряный прямоугольник</b> – не действуют фигуры в том же ряду,
        когда светится^
        <b>Серебряный треугольник</b> – фигуры в соседних рядах не действуют,
        никакая другая фигура не может отключить этот эффект^
        <b>Серебряный круг</b> – если не светится, тело начинает каменеть^
        ^
        <b>Медный квадрат</b> – золотые фигуры не действуют, если не светится^
        <b>Медный прямоугольник</b> – когда не светится, гасит все
        треугольники^
        <b>Медный треугольник</b> – ключ становится материальным, когда не
        светится^
        <b>Медный круг</b> – убивает, если светится или не действует^
        ]];
    end,
    obj =
    {
        vway('1', '{Назад}', 'city_square'),
    },
    exit = function (s, to)
        if to == city_square then
            back ();
        end
    end,
};


figures_puzzle_room = xroom
{
    nam = true,
    _key_taken = false,
    dsc = function (s)
        local t;
        local gs_on  = 'gs_on';
        local gs_off = 'gs_off';
        local sc_on  = 'sc_on';
        local sc_off = 'sc_off';
        local sr_on  = 'sr_on';
        local sr_off = 'sr_off';
        local ct_on  = 'ct_on';
        local ct_off = 'ct_off';

        local gc_on  = 'gc_on';
        local gc_off = 'gc_off';
        local st_on  = 'st_on';
        local st_off = 'st_off';
        local cc_on  = 'cc_on';
        local cc_off = 'cc_off';
        local gt_on  = 'gt_on';
        local gt_off = 'gt_off';

        local ss_on  = 'ss_on';
        local ss_off = 'ss_off';
        local gr_on  = 'gr_on';
        local gr_off = 'gr_off';
        local cr_on  = 'cr_on';
        local cr_off = 'cr_off';
        local cs_on  = 'cs_on';
        local cs_off = 'cs_off';
        local exit_f = 'exit_f';

        t = '';
        if not gold_square then
            t = t..'{faction_xact('..gs_on..')|'..img('images/f_gold_square.png')..'}';
        else
            t = t..'{faction_xact('..gs_off..')|'..img('images/f_gold_square_a.png')..'}';
        end
        if not silver_circle then
            t = t..'{faction_xact('..sc_on..')|'..img('images/f_silver_circle.png')..'}';
        else
            t = t..'{faction_xact('..sc_off..')|'..img('images/f_silver_circle_a.png')..'}';
        end
        if not silver_rectangle then
            t = t..'{faction_xact('..sr_on..')|'..img('images/f_silver_rectangle.png')..'}';
        else
            t = t..'{faction_xact('..sr_off..')|'..img('images/f_silver_rectangle_a.png')..'}';
        end
        if not copper_triangle then
            t = t..'{faction_xact('..ct_on..')|'..img('images/f_copper_triangle.png')..'}';
        else
            t = t..'{faction_xact('..ct_off..')|'..img('images/f_copper_triangle_a.png')..'}';
        end
        t = t..'^';

        if not gold_circle then
            t = t..'{faction_xact('..gc_on..')|'..img('images/f_gold_circle.png')..'}';
        else
            t = t..'{faction_xact('..gc_off..')|'..img('images/f_gold_circle_a.png')..'}';
        end
        if not silver_triangle then
            t = t..'{faction_xact('..st_on..')|'..img('images/f_silver_triangle.png')..'}';
        else
            t = t..'{faction_xact('..st_off..')|'..img('images/f_silver_triangle_a.png')..'}';
        end
        if not copper_circle then
            t = t..'{faction_xact('..cc_on..')|'..img('images/f_copper_circle.png')..'}';
        else
            t = t..'{faction_xact('..cc_off..')|'..img('images/f_copper_circle_a.png')..'}';
        end
        if not gold_triangle then
            t = t..'{faction_xact('..gt_on..')|'..img('images/f_gold_triangle.png')..'}';
        else
            t = t..'{faction_xact('..gt_off..')|'..img('images/f_gold_triangle_a.png')..'}';
        end
        t = t..'^';

        if not silver_square then
            t = t..'{faction_xact('..ss_on..')|'..img('images/f_silver_square.png')..'}';
        else
            t = t..'{faction_xact('..ss_off..')|'..img('images/f_silver_square_a.png')..'}';
        end
        if not gold_rectangle then
            t = t..'{faction_xact('..gr_on..')|'..img('images/f_gold_rectangle.png')..'}';
        else
            t = t..'{faction_xact('..gr_off..')|'..img('images/f_gold_rectangle_a.png')..'}';
        end
        if not copper_rectangle then
            t = t..'{faction_xact('..cr_on..')|'..img('images/f_copper_rectangle.png')..'}';
        else
            t = t..'{faction_xact('..cr_off..')|'..img('images/f_copper_rectangle_a.png')..'}';
        end
        if not copper_square then
            t = t..'{faction_xact('..cs_on..')|'..img('images/f_copper_square.png')..'}';
        else
            t = t..'{faction_xact('..cs_off..')|'..img('images/f_copper_square_a.png')..'}';
        end
        t = t..'^{faction_xact('..exit_f..')|<c>Отойти от стола</c>}';

        return t;
    end,
    enter = function (s, from)
        if check_gold_circle() == 1 then
            silver_triangle = false;
            copper_circle = false;
            gold_triangle = false;
        end

        if check_copper_rectangle() == 1 then
            silver_triangle = false;
            copper_triangle = false;
            gold_triangle = false;
        end

        if check_copper_circle() == 1 then
            p [[Ужасающая боль пронзает твоё тело и ты теряешь сознание.
            Похоже, тебя постигла та же участь, что мужчину, чей скелет ты
            обнаружил в этой комнате.
            ]];
            walk (death);
            return;
        end

        if check_silver_circle() == 1 then
            if (imprisoned == 3) then
                p [[Всё твоё тело онемело, ты не можешь пошевельнуть и
                пальцем. Похоже, тебя постигла та же участь, что мужчину, чей
                скелет ты обнаружил в этой комнате.
                ]];
                walk (death);
                return;
            end
            imprisoned = imprisoned + 1;
        else
            imprisoned = 0;
        end

        key_visible_before = key_visible;
        if check_silver_square() == 1 then
            key_visible = true;
        else
            key_visible = false;
        end

        if check_copper_triangle() == 1 and key_visible then
            key_takable = true;
        else
            key_takable = false;
        end

        if key_takable then
            if key_visible_before then
                p 'Ты берёшь золотой ключ.';
            else
                p 'Ты берёшь золотой ключ, появившийся возле фигур.';
            end
            s._key_taken = true;
            take (key_gold);
            imprisoned = 0;
            walk (mages_tower_figures_room);
            return;
        end

        if key_visible == 1 then
            if key_visible_before then
                p 'Возле фигур лежит полупрозрачный золотой ключ.';
            else
                p 'Возле фигур появляется полупрозрачный золотой ключ.';
                if not tried_take then
                    tried_take = true;
                    p [[Твоя рука проходит сквозь ключ, когда ты пытаешься
                    взять его.
                    ]];
                end
            end
        end

        if imprisoned == 1 then
            p [[Твои ноги онемели по колено и ты не можешь сдвинуться с места.
            ]];
        end
        if imprisoned == 2 then
            p [[Твоё тело онемело по пояс и ты не можешь сдвинуться с места.
            ]];
        end

    end,
    exit = function (s, to)
        if to == death then
            return;
        end
        if imprisoned > 0 then
            p [[Твоё тело онемело и ты не можешь сдвинуться с места.
            ]];
            return false;
        end
    end,
};


key_gold = obj
{
    nam = 'золотой ключ',
    inv = 'Массивный золотой ключ.',
    use = function (s, w)
        if w == book_door then
            drop (s);
            s:disable();
            book_door._gold_lock = false;
            p [[Как только ты поворачиваешь ключ в замке, золотой замок
            исчезает.
            ]];
        end
    end,
};


mages_tower_4 = room
{
    nam = 'Башня магов. Этаж 4',
    dsc = function (s)
        p [[Площадка на вершине башни. Круговая лестница ведёт вниз.
        ]];
    end,
    obj =
    {
        'book_door',
    },
    way =
    {
        vroom ('Спуститься по лестнице', 'mages_tower_3'),
        vroom ('В дверь', 'mages_tower_book_room'),
    },
    exit = function (s, to)
        if to == mages_tower_book_room then
            if book_door._gold_lock or book_door._silver_lock or book_door._copper_lock then
                p 'Окованная железом дверь заперта.';
                return false;
            end
        end
    end,
};


book_door = obj
{
    nam = 'дверь',
    _gold_lock = true,
    _silver_lock = true,
    _copper_lock = true,
    dsc = function (s)
        if s._gold_lock or s._silver_lock or s._copper_lock then
            p [[Окованная железом {дверь} заперта.
            ]];
        else
            p [[Окованная железом дверь открыта.
            ]];
        end
    end,
    act = function (s)
        if s._gold_lock or s._silver_lock or s._copper_lock then
            p [[Окованная железом дверь заперта на
            ]];
            if s._gold_lock and s._silver_lock and s._copper_lock then
                p [[три замка – золотой, серебряный и медный.
                ]];
            end
            if not s._gold_lock and s._silver_lock and s._copper_lock then
                p [[два замка – серебряный и медный. Золотой замок открыт.
                ]];
            end
            if s._gold_lock and not s._silver_lock and s._copper_lock then
                p [[два замка – золотой и медный. Серебряный замок открыт.
                ]];
            end
            if s._gold_lock and s._silver_lock and not s._copper_lock then
                p [[два замка – золотой и серебряный. Медный замок открыт.
                ]];
            end
            if s._gold_lock and not s._silver_lock and not s._copper_lock then
                p [[золотой замок. Серебряный и медный замки открыты.
                ]];
            end
            if not s._gold_lock and s._silver_lock and not s._copper_lock then
                p [[серебряный замок. Золотой и медный замки открыты.
                ]];
            end
            if not s._gold_lock and not s._silver_lock and s._copper_lock then
                p [[медный замок. Золотой и серебряный замки открыты.
                ]];
            end
        else
            p [[Окованная железом дверь открыта.
            ]];
        end
    end,
};


mages_tower_book_room = room
{
    nam = 'Квадратная комната',
    dsc = function (s)
        p [[Небольшая почти пустая квадратная комната. Единственная
        находящаяся в ней вещь — стоящий в центре высокий пюпитр.
        ]];
    end,
    obj =
    {
        'book'
    },
    way =
    {
        vroom ('В дверь', 'mages_tower_4'),
    },
};


book = obj
{
    nam = 'книга',
    _readed = false,
    dsc = function (s)
        p [[На пюпитре лежит закрытая {книга} в богатом кожаном переплёте. На
        обложке и корешке книги ничего не написано.
        ]];
    end,
    tak = 'Ты берёшь книгу с пюпитра.',
    inv = function (s)
        take (spell_zodacare);
        take (spell_keneb);
        walk (book_read);
    end,
};


book_read = room
{
    nam = 'Книга',
    hideinv = true,
    pic = 'images/book.png',
    dsc = function (s)
        magician_dlg:pon ('focus');
        magician_dlg:pon ('circle');
        magician_dlg:pon ('herbs');
        magician_dlg:pon ('storage');
        magician_dlg:pon ('demon');
        p [[В книге много сложных и запутанных описаний магических ритуалов,
        причём чаще всего есть только название ритуала, но нет указаний на то,
        зачем он нужен.^
        Где-то в середине книги ты находишь нужный ритуал.^^
        <b><c>Описание ритуала «Delumbo malum»</c></b>^
        Для этого ритуала необходимо:^
        - в точке магического фокуса нарисовать защитный круг второго
        порядка;^
        - вписать в круг пентаграмму, направленную лучом на объект
        воздействия;^
        - установить на вершинах пентаграммы свечи с добавлением багульника
        болотного и паслёна чёрного;^
        - установить в центр пентаграммы предмет-накопитель;^
        - зажечь свечи;^
        - громко произнести «Zodacare Gohusa od Zodameranu»^^
        Перед началом ритуала объект воздействия должен быть максимально
        ослаблен, в противном случае существует вероятность предпочтения
        накопителя, и энергия будет вытянута из проводящего ритуал. То же
        самое касается и порядка выполнения действий.^
        Для получения энергии из накопителя необходимо взять его в руку и
        произнести «Keneb Esaya Taaruterosh».
        ]];
    end,
    obj =
    {
        vway('1', '{Назад}', 'mages_tower_book_room'),
    },
    exit = function (s, to)
        back ();
    end,
};


spell_zodacare = obj
{
    nam = '«Zodacare…»',
    inv = function (s)
        if here () == laboratory_ritual_chamber and not ritual_error and girl._dispelled and dreamer._awake and artist._dispelled and seen (candles) and candles._burning then
            if not ritual_finished then
                p [[В статуэтке загорается багровый огонёк. Через несколько
                мгновений тебя ослепляет яркая вспышка.
                ]];
                ritual_finished = true;
                statuette._force = true;
                return;
            else
                p [[В статуэтке загорается багровый огонёк. Через несколько
                мгновений тебя ослепляет яркая вспышка.^
                Через мгновение ты снова начинаешь видеть окружающее. Ты
                смотришь на статуэтку. Она начинает вибрировать и вдруг
                разлетается на осколки с оглушающим хлопком. Похоже, статуэтка
                была переполнена силой.^
                Всё меркнет у тебя перед глазами.
                ]];
                walk (death);
                return;
            end
        else
            p [[Ты ощущаешь, как с каждой секундой силы покидают тебя. При
            проведении ритуала ты где-то допусти ошибку, и теперь демон станет
            только сильней.
            ]];
            walk (death);
            return;
        end
        p [[Ты произносишь «Zodacare Gohusa od Zodameranu». Ничего не
        происходит.
        ]];
    end,
    tak = function (s)
        return true;
    end,
};


spell_keneb = obj
{
    nam = '«Keneb Esaya…»',
    inv = function (s)
        if have (statuette) and ritual_finished and statuette._force then
            statuette._force = false;
            p [[Ты чувствуешь, как огромным потоком в тебя вливается сила. Мощь переполняет тебя. Скоро весь мир будет в твоей власти.
            ]];
            return;
        end
        p [[Ты произносишь «Keneb Esaya Taaruterosh». Ничего не происходит.
        ]];
    end,
};


mansion = room
{
    nam = 'Особняк. Холл',
    dsc = function (s)
        p [[Когда-то холл этого дома блистал великолепием, но время было к
        нему беспощадно и сейчас мебель покрыта густым слоем пыли, а стены
        и потолок затянуты паутиной. Дверь, ведущая в гостиную, сорвана с
        петель и валяется на полу. Лестница с прогнившими ступенями ведёт
        на второй этаж.
        ]];
    end,
    obj =
    {
        'mansion_hall_paintings'
    },
    way =
    {
        vroom ('В гостиную', 'mansion_reception_room'),
        vroom ('На второй этаж', 'mansion_bedroom'),
        vroom ('На площадь', 'city_square'),
    },
};


mansion_hall_paintings = obj
{
    nam = 'картины в холле',
    _dispelled = false,
    dsc = function (s)
        p [[На фоне этого запустения выделяются {две картины} в резных рамах.
        ]];
    end,
    act = function (s)
        if s._dispelled then
            p [[На картине, висящей напротив входной двери, изображена
            красивая молодая пара. На второй картине по весеннему лесу,
            залитому солнечным светом, прогуливается охотник.
            ]];
        else
            p [[На картине, висящей напротив входной двери, изображён
            красивый жених, срывающий лицо со своей ничего не
            подозревающей невесты. На второй картине безглазый человек
            пробирается через лес искривлённых смеющихся деревьев.
            ]];
        end
    end,
};


mansion_reception_room = room
{
    nam = 'Особняк. Гостиная',
    dsc = function (s)
        p [[Вокруг стола из красного дерева в центре комнаты стоят несколько
        кресел с дорогой обивкой.^
        Мраморный камин настолько покрыт копотью, что только редкие островки
        белого цвета пробиваются сквозь черноту.
        ]];
    end,
    obj =
    {
        'cover',
        'doll_porcelain',
        'mansion_reception_hall_paintings'
    },
    way =
    {
        vroom ('В холл', 'mansion'),
    },
};


cover = obj
{
    nam = 'чехол',
    dsc = function (s)
        if here() == mansion_reception_room then
            p 'На одном из кресел висит {чехол}.';
            return;
        end
        if mirror_left._covered then
            p 'Зеркало на левой стене завешено {чехлом} для мебели.';
        else
            p 'Зеркало на правой стене завешено {чехлом} для мебели.';
        end
    end,
    tak = function (s)
        mirror_left._covered = false;
        mirror_right._covered = false;
        if seen (key_copper) then
            key_copper:disable();
        end
        p 'Ты берёшь чехол.';
    end,
    inv = 'Чехол для мебели из дорогой ткани.',
    use = function (s, o)
        if o == mirror_left then
            mirror_left._covered = true;
            drop (s);
            p 'Ты занавешиваешь зеркало на левой стене чехлом для мебели.';
        end
        if o == mirror_right then
            mirror_right._covered = true;
            drop (s);
            p 'Ты занавешиваешь зеркало на правой стене чехлом для мебели.';
        end
    end,
};


doll_porcelain = obj
{
    nam = 'фарфоровая кукла',
    dsc = function (s)
        if here () == mansion_reception_room then
            p [[На каминной полке стоит небольшая {кукла}.
            ]];
        else
            p [[На полу лежит {кукла}.
            ]];
        end
    end,
    tak = function (s)
        if here () == church_basement then
            lifeon (doll_rag);
            p [[Как только ты поднимаешь куклу, тьма в подвале сгущается. Алтарь
            со скрежетом закрывает проход.
            ]];
        else
            p 'Ты берёшь куклу.';
        end
    end,
    inv = function (s)
        p [[Кукла из дорогого фарфора одета в платье из дорогой ткани.
        ]];
    end,
    use = function (s, o)
        if o == girl then
            p '«Нет, это не моя Мари,» – всхлипывает девочка.';
        end
    end,
    use = function (s, w)
        if w == doll_rag then
            drop (s);
            take (doll_rag);
            p 'Ты меняешь фарфоровую куклу на тряпичную.';
        end
    end,
};


mansion_reception_hall_paintings = obj
{
    nam = 'картины',
    _dispelled = false,
    dsc = function (s)
        p [[По бокам камина висят {две картины}. Сквозь дверной проём виден
        холл.
        ]];
    end,
    act = function (s)
        if s._dispelled then
            p [[На картине справа от камина изображена улыбающаяся молодая
            девушка, кормящая с ладони голубя. На картине слева изображён
            молодой парень, собирающийся жать рожь.
            ]];
        else
            p [[На картине справа от камина изображена сердитая ведьма,
            пытающаяся вырвать из своих волос летучую мышь. На картине слева
            изображено чучело в центре ржаного поля, на плечи которого
            насажена отрезанная человеческая голова.
            ]];
        end
    end,
};


mansion_bedroom = room
{
    nam = 'Особняк. Спальня',
    enter = function (s)
        artist._seen = true;
        magician_dlg:pon ('others');
    end,
    obj =
    {
        'mansion_bedroom_paintings',
        'artist'
    },
    way =
    {
        vroom ('В холл', 'mansion'),
    },
};


mansion_bedroom_paintings = obj
{
    nam = 'картины',
    _dispeled = false,
    dsc = function (s)
        p [[В центре комнаты на мольберте установлена законченная {картина}.
        ]];
    end,
    act = function (s)
        if s._dispelled then
            p [[На картине изображён огромный зал, заполненный танцующими
            парами.
            ]];
        else
            p [[На картине изображён огромный зал, заполненный танцующими
            парами. К большинству пар прикреплены нити, которые используются
            для марионеток. Несколько пар валяются бесформенными грудами на
            мозаичном полу, их нити перерезаны.
            ]];
        end
    end,
};


artist = obj
{
    nam = 'художник',
    _seen = false,
    _dispelled = false,
    dsc = function (s)
        p [[Перед мольбертом сидит богато одетый {мужчина}. Его взгляд
        устремлён в одну точку и он никак не реагирует на твоё появление.
        ]];
    end,
    act = function (s)
        p [[Мужчина совсем не реагирует на попытки заговорить с ним, только
        иногда он поднимает взгляд на картину на мольберте и вздыхает.
        ]];
    end,
    check_dispelled = function (s)
        if mansion_hall_paintings._dispelled and mansion_reception_hall_paintings._dispelled and mansion_bedroom_paintings._dispelled then
            artist._dispelled = true;
            if seen (s) then
                p [[На лице мужчины появляется улыбка. Его тело становится всё
                более прозрачным, и спустя мгновение он исчезает.
                ]];
            end
            s:disable();
        end
    end,
};


dream_room = room
{
    nam = 'Хижина',
    _awake = false,
    enter = function (s)
        dreamer._seen = true;
        magician_dlg:pon ('others');
    end,
    dsc = function (s)
        p [[Сразу видно, что это комната бедняка. В ней почти нет мебели.
        Несколько полок на стенах покрыты густым слоем пыли.
        ]];
        if not seen (dreamer) then
            p [[Деревянная кровать в углу комнаты пуста.
            ]];
        end
    end,
    obj =
    {
        'dreamer',
        'candles',
    },
    way =
    {
        vroom ('На площадь', 'city_square'),
    },
};


dreamer = obj
{
    nam = 'спящий',
    _awake = false,
    _seen = false,
    _time_to_say = 5,
    dsc = function (s)
        p [[На деревянной кровати в углу комнаты спит {мужчина}.
        ]];
    end,
    act = function (s)
        p [[Мужчина средних лет погружён в крепкий сон. На все попытки
        разбудить его он реагирует только неразборчивым бормотанием.
        ]];
    end,
    life = function (s)
        if s._time_to_say == 0 then
            s._time_to_say = math.random (15) + 10;
            s.sleep_say ();
        else
            s._time_to_say = s._time_to_say - 1;
--            print (s._time_to_say);
        end
    end,
    sleep_say = function (s)
        local phrases =
        {
            'Не оставляйте утку там. Это же совершенно безответственно. Посадите её на качели, пусть порадуется.',
            'Мне нравится, что ты лось. Да. Такой пушистый-пушистый.',
            'Ты не можешь быть пиратом, если у тебя нет бороды. Я так сказал. Мой корабль — мои правила.',
            'Ты милая. Милая-милая-милая-милая. А теперь иди отсюда и будь милой где-нибудь в другом месте. Мне надоело.',
            'Не надо. Не сажайте лапшу и пельмени в одну лодку. Они будут драться. Лапша хулиганит. Бедные пельмени.',
            'Я не могу справиться с котятами. Слишком много усов! Слишком много усов!',
            'Цок-цок, цок-цок. Сделайте так, чтобы копыта не стучали! Кто привёл лошадь в спальню? А-а-а… Похоже, я сплю в сарае.',
            'Тсссссс! Тсссссс! Говорю тебе: твой голос, мои уши. Плохая комбинация.',
            'Я хочу быть ковбоем. Я не хочу быть пандой. Панды глупые и скучные. Плохая панда!',
            'С каких это пор моё нижнее белье тебе идёт? Сними его! Сними его с лица!',
            'Я не хочу умирать! Я люблю секс. И пушистых животных.',
            'Я не прибавил в весе, это твои глаза жирные.',
            'Я за-ме-ча-тель-ный. Попробуй с этим справиться, говнюк!',
            'Твоя мама снова в дверях. Похорони меня. Закопай меня глубоко…',
            'Пожалуйста, проходите мимо, иначе я должен буду стоять здесь и говорить что-то настолько захватывающее, что мне придётся помнить это весь остаток дня, а я этого не хочу. Спасибо!',
            'А теперь отвали и дай мне погреться в лучах счастья быть мной.',
            'Я не могу верить в Бога, когда я ТАКОЙ хороший!',
            'Дай-ка я тебя обниму. Почувствуй, как я сдавливаю твоё жалкое тельце. Блаженство. Чудесно.',
            'Когда забиваешь на работу, дела идут на лад.',
            'Я бы предпочёл ободрать с себя кожу и искупаться в уксусе, чем общаться с тобой. Но это просто мое мнение. Не принимай близко к сердцу.',
            'Когда щекочете бобра, будьте осторожны.',
            'Пушистый зайка + любопытный нос + большие уши = супер-смесь.',
            'У меня ужасные, ужасные, ужасные предчувствия насчёт заварного пирога. Ужасные.',
            'Я весь синий в жирную крапинку. И я горжусь этим.',
            'Знаешь, ты вовсе не какой-нибудь там прекрасный цветок. Да даже если бы и был, я бы стал травой и вырос бы рядом, чтобы ЗАДУШИТЬ ТЕБЯ НА ХРЕН!.. Люблю тебя!',
            'Не ешь желе! Не ешь желе! Я из лягушечки его сделал. У тебя зубы позеленеют… Будут как маленькие яблоки.',
            'Нет, только не кошки. Не верь им. Их глаза. Их глаза. Они знают слишком много.',
            'Конечно, зомби любила меня. Она отдала мне своё сердце. М-м-х-х-м-м. И свою руку после замужества.',
            'Верни мне назад мои руки! Похититель конечностей. У тебя все руки в пальцах ',
            'Эй, я знаю тебя, но мне не нравится твоё лицо. Сними его… Да, так-то намного лучше, намного лучше.',
            'Пингвины-вампиры? Морские свинки-зомби? Мы мертвы… мертвы. Я не хочу умирать! Я люблю секс. И пушистых животных.',
        };
        local say =
        {
            'бормочет сквозь сон мужчина на кровати.',
            'раздаётся неожиданно со стороны кровати.',
            'ненадолго нарушает тишину голос спящего.',
        };
        local ph = math.random (#phrases);
        local s = math.random (#say);
        p ('«'..phrases[ph]..'» –');
        p (say[s]);
    end,
};


candlestick = obj
{
    nam = 'подсвечник',
    _candle = false,
    dsc = function (s)
        if here () == church_store_room then
            p [[Деревянные полки у стен настолько затянуты паутиной, что
            {серебряный подсвечник} на одной из них почти не заметен.
            ]];
        else
            p [[В центре возвышения в небольшом углублении стоит {серебряный
            подсвечник}.
            ]];
        end
    end,
    obj =
    {
        'candle',
    },
    tak = function (s)
        if not s._candle then
            p 'Ты забираешь подсвечник.';
        else
            s._candle = false;
            candle._burning = false;
            candles._number = candles._number + 1;
            candle:disable ();
            p 'Ты забираешь свечу и подсвечник.';
            altar:check_restore ();
        end
    end,
    inv = function (s)
        p [[Тяжёлый серебряный подсвечник с треугольным основанием. Судя по
        царапинам на основании, он часто крепился в каком-то углублении.
        ]];
    end,
    use = function (s, o)
        if o == altar_lacuna then
            drop (s);
            p [[Ты устанавливаешь подсвечник в углубление в алтаре.
            ]];
        end
    end,
};


candles = obj
{
    nam = 'свечи',
    _number = 5,
    _labrador_tea = false,
    _nightshade = false,
    _ritual_location = '',
    _burning = false,
    dsc = function (s)
        if here () == dream_room then
            p 'На столике возле кровати лежит несколько {восковых свечей}.';
        end
        if here () == laboratory_ritual_chamber then
            if s._ritual_location == 'block' then
                p 'По поверхности блока расставлены пять';
            end
            if s._ritual_location == 'circle' then
                p 'Вдоль защитного круга расставлены пять';
            end
            if s._ritual_location == 'pentagram' then
                p 'На лучах пентаграммы стоят пять';
            end
            if not s._burning then
                p '{свечей}.';
            else
                p 'зажжённых свечей.';
            end
        end
    end,
    tak = function (s)
        p [[Ты берёшь свечи.
        ]];
    end,
    inv = function (s)
        if s._labrador_tea or s._nightshade then
            p 'Свечи с травами.';
        else
            p 'Восковые свечи.';
        end
        if s._number == 5 then
            p '5 штук.';
        end
        if s._number == 4 then
            p '4 штуки.';
        end
        if s._number == 3 then
            p '3 штуки.';
        end
        if s._number == 2 then
            p '2 штуки.';
        end
        if s._number == 1 then
            p '1 штука.';
        end
    end,
    use = function (s, o)
        if o == candlestick and here () == church_altar and seen (candlestick) then
            if candlestick._candle then
                p 'В подсвечнике уже есть свеча.';
            else
                candles._number = candles._number - 1;
                candlestick._candle = true;
                candle:enable();
                p 'Ты вставляешь свечу в подсвечник.';
            end
        end
        if o == bowl and seen (bowl) then
            if s._number < 5 then
                p 'Требуется пять свечей.';
                return;
            end
            if s._number == 5 then
                bowl._candles = true;
                candles:disable ();
                p 'Ты кладёшь пять свечей в миску.';
                bowl:melt ();
            end
        end
        if o == stone_block and stone_block._focus_found then
            if s._number < 5 then
                p 'Требуется пять свечей.';
                return;
            end
            if s._number == 5 then
                s._ritual_location = 'block';
                ritual_error = true;
                drop (s);
                p 'Ты расставляешь свечи на блоке.';
            end
        end
        if o == circle_of_defence then
            if s._number < 5 then
                p 'Требуется пять свечей.';
                return;
            end
            if s._number == 5 then
                s._ritual_location = 'circle';
                ritual_error = true;
                drop (s);
                p 'Ты расставляешь свечи на защитном круге.';
            end
        end
        if o == pentagram then
            if s._number < 5 then
                p 'Требуется пять свечей.';
                return;
            end
            if s._number == 5 then
                s._ritual_location = 'pentagram';
                drop (s);
                p 'Ты расставляешь свечи на лучи пентаграммы.';
            end
        end
    end,
};


candle = obj
{
    nam = 'свеча',
    _burning = false,
    dsc = function (s)
        if not s._burning then
            p [[В него вставлена {свеча}.
            ]];
        else
            p [[В нём горит {свеча}.
            ]];
        end
    end,
    act = function (s)
        s:disable();
        candles._number = candles._number + 1;
        candlestick._candle = false;
        if s._burning then
            s._burning = false;
            p 'Ты гасишь свечу и забираешь её.';
        else
            p 'Ты берёшь свечу.';
        end
        altar:check_restore ();
    end,
}:disable();


mages_hall = room
{
    nam = 'Коттедж. Холл',
    dsc = function (s)
        p [[Огромный холл выглядит совсем заброшенным. Все вещи покрыты
        толстым слоем пыли. Углы комнаты затянуты паутиной. И только дверь в
        кабинет выглядит нетронутой временем.
        ]];
    end,
    way =
    {
        vroom ('В кабинет', 'mages_hall_cabinet'),
        vroom ('На площадь', 'city_square'),
    },
};


mages_hall_cabinet = room
{
    nam = 'Коттедж. Кабинет',
    dsc = function (s)
        p [[Обстановка комнаты изыскана и изящна. Мебели сравнительно немного:
        стол, несколько кресел, этажерка, шкаф-секретер и массивный сундук,
        украшенный бронзовыми завитушками и резьбой.
        ]];
    end,
    obj =
    {
        'gobelin',
        'diplomas',
        'magician',
        'letter',
        'statuette',
        'stick'
    },
    way =
    {
        vroom ('В холл', 'mages_hall'),
    },
};


gobelin = obj
{
    nam = 'гобелен',
    dsc = function (s)
        p [[Одну из стен украшает очень красивый и, по-видимому, очень дорогой
        {гобелен}.
        ]];
    end,
    act = function (s)
        walk (gobelin_dlg);
    end,
};


gobelin_dlg = dlg
{
    nam = 'Гобелен',
    hideinv = true,
    dsc = function (s)
        p [[На гобелене изображён суровый горный пейзаж, в центре которого –
        огромная мрачная пещера. Выступающие острые края камней придают ей
        сходство с гигантской оскаленной пастью. Издали к пещере скачет рыцарь
        в белоснежном развевающемся плаще. Рыцарь гордо трубит в рог, рука его
        сжимает боевое копье, доспехи блещут на солнце, но по сравнению с
        огромным отверстым  зевом пещеры он кажется совсем крохотным,
        ничтожным и беспомощным. Несмотря на яркость и свежесть красок, на
        завораживающую красоту, картина производит очень мрачное, напряжённое,
        тревожное впечатление.
        ]];
    end,
    phr =
    {
        {
            always = true,
            [[Осмотреть гобелен.]],
            [[Когда ты внимательней присматриваешься к пещере, тебе начинает
            казаться, что она ведёт не внутрь горы, а в никуда. Тьма в её
            глубине зовёт и притягивает, и тебе с трудом удаётся оторвать
            взгляд.
            ]]
        };
        {
            always = true,
            [[Коснуться гобелена.]],
            [[Мрак в глубине пещеры начинает втягивать тебя. Противостоять ему
            невозможно и вскоре ты оказываешься в кромешной тьме. Тебе суждено
            оставаться здесь вечно.
            ]],
            code = [[ walk (death); ]]
        };
        {
            always = true,
            [[Назад.]],
            [[Ты отходишь от гобелена.]],
            code = [[ back (); ]]
        };
    },
};


diplomas = obj
{
    nam = 'дипломы',
    dsc = function (s)
        p [[На другой стене, над столом в деревянной рамке висят два
        {диплома}.
        ]];
    end,
    act = function (s)
        p [[Первый из дипломов, выданный Магической гильдией Северного предела
        за подписью главы гильдии мастера Ургана, гласит о принятии в гильдию
        Ульриха, ученика Ургана, а второй — диплом Великого Совета Магов о
        присвоении магу Ульриху из гильдии Северного предела звания мастера
        магии.
        ]];
    end,
};


letter = obj
{
    nam = 'письмо',
    _readed = false,
    dsc = function (s)
        if not s._readed then
            p [[На столе стоит красивый письменный прибор, украшенный золотом
            и самоцветами, и лежит {лист бумаги}.
            ]];
        else
            p [[На столе стоит красивый письменный прибор, украшенный золотом
            и самоцветами, и лежит пепел в форме листа бумаги.
            ]];
        end
    end,
    act = function (s)
        take (spell_hortor_ulrich);
        walk (letter_read);
    end,
};


letter_read = room
{
    nam = true,
    hideinv = true,
    pic = 'images/letter.jpg',
    dsc = function (s)
        p [[– Я очень долго сражался со злом, проникшим в наш город, но силы
        мои на исходе. И хотя я нашёл-таки способ избавиться от проклятия,
        сделать это я уже не смогу. Единственное что мне остаётся – древний
        ритуал, позволяющий задержаться в этом мире в виде призрака.^
        Если ты читаешь это письмо, значит ты был достаточно глуп или смел,
        чтобы прийти в город. Но пока действует проклятье, покинуть его ты не
        сможешь.^
        Произнеси «Hortor Ulrich», чтобы призвать меня – вместе мы сможем
        избавить город от проклятия.^
        И я, наконец, обрету покой, а ты сможешь вернуться к обычной жизни.^^
        <i><c>Маcтep магии Ульрих из гильдии Северного Предела</c></i>
        ]];
    end,
    obj =
    {
        vway('1', '{Назад}', 'mages_hall_cabinet'),
    },
};


spell_hortor_ulrich = obj
{
    nam = '«Hortor Ulrih»',
    inv = function (s)
        if here () == mages_hall_cabinet and seen (letter) then
            letter._readed = true;
            magician:enable();
            p [[Ты произносишь «Hortor Ulrih». Письмо вспыхивает белым
            бездымным пламенем и в кресле за столом появляется полупрозрачный
            силуэт мужчины.
            ]];
            return;
        end
        p [[Ты произносишь «Hortor Ulrih». Ничего не происходит.
        ]];
    end,
    tak = function (s)
        return true;
    end,
};


magician = obj
{
    nam = 'маг',
    dsc = function (s)
        p [[В кресле за столом виден полупрозрачный силуэт {мужчины}.
        ]];
    end,
    act = function (s)
        walk (magician_dlg);
    end,
}:disable ();


magician_dlg = dlg
{
    nam = 'Маг',
    hideinv = true,
    phr =
    {
        {
            [[Кто ты?]],
            [[– Здравствуй, путник. Меня зовут Ульрих. Я Мастер магии из
            гильдии Северного предела.
            ]],
            code = [[ pon ('city'); ]]
        },
        {
            tag = 'city',
            false,
            [[Что случилось с городом?]],
            [[– Позволь мне рассказать, что же случилось с Лендалом.^
            Где-то через пару недель после того, как я защитил звание мастера
            магии, возле одной из исследовательских лабораторий в небо ударил
            столб чёрного пламени. Почти сразу от лаборатории на город начал
            наползать густой туман.^
            Мне повезло, что я занимался исследованием демонических сущностей
            и сразу понял, что произошло. Такое пламя образуется при прорыве
            круга подчинения. Кто-то вызвал демона и не смог удержать его под
            контролем. Что же до тумана – это способность самых сильных
            демонов призывать Дыхание бездны. Это полуразумная сущность
            обладает способностью вытягивать жизненные силы из живых существ и
            делиться ей с призвавшим. Защиты от неё практически не существует,
            сильный маг продержится не более полчаса. Времени у меня было
            мало, я успел только написать письмо и воспользоваться древним
            ритуалом, превращающим человека в призрака.^
            Выжить в этом тумане можно только попав в него в период спячки
            Дыхания бездны, а это всего один день раз в десять лет. Так что
            тебе сильно повезло, что ты попал в город именно в это время. Но
            войдя в туман в период спячки, выйти из него уже не получится.
            Дыхание бездны не упускает своих жертв.^
            Так что, если хочешь выжить, тебе нужно развеять туман. Для этого
            необходимо уничтожить призвавшего, а это не так просто.
            ]],
            code = [[ pon ('summoner'); ways (city_square):add (vroom ('К лаборатории', 'laboratory_front')); ]]
        },
        {
            tag = 'summoner',
            false,
            [[Как снять проклятие?
            ]],
            [[– Здесь поможет только ритуал Delumbo malum, вытягивающий силы
            из объекта воздействия. К сожалению я только слышал о этом
            ритуале, но не знаю как он должен проводится. Его описание есть в
            большой книге ритуалов в северной башне Гильдии магов. Чтобы войти
            в неё произнеси «Entero Vidis», когда будешь возле здания.
            ]],
            code = [[ take (spell_entero_vidis); ]]
        },
        {
            tag = 'well_water',
            false,
            [[Почему вода в колодце возле лаборатории чёрного цвета?
            ]],
            [[– Это очень редкий феномен, я только читал о таких. Иногда после
            призыва очень сильных демонов вода в колодцах неподалёку от места
            призыва становится чёрной. Такая вода – сильнейший нейтрализатор
            магии, достаточно одной капли, чтобы снять любое заклятье или
            лишить силы магический предмет. Но с ней нужно быть очень
            осторожным – если ты её коснёшься, вода вытянет из тебя все силы.
            И только специальные ёмкости могут удержать её – остальные просто
            лопаются. В магических лабораториях такие ёмкости обычно
            окрашивались в красный цвет.
            ]],
            code = [[ retort_red._know = true; ]]
        },
        {
            tag = 'others',
            false,
            [[Как могли выжить в тумане другие?
            ]],
            [[– Похоже, ситуация ещё хуже чем я предполагал. Только самые
            сильные демоны в состоянии контролировать Дыхание бездны
            настолько, что оно сохраняет жизнь Опорам. Так называют людей, от
            которых демон получает силу. Чаще всего это сильные эмоции. Если у
            призванного демона есть Опоры, то он постепенно копит силы и
            когда-нибудь сможет освободиться.
            ]]
        },
        {
            tag = 'focus',
            false,
            always = true,
            [[Где находится точка магического фокуса?
            ]],
            [[– В лаборатории есть комната, стены которой покрыты защитными
            рунами и узорами. Стоящий в её центре каменный блок и будет точкой
            магического фокуса.
            ]],
            code = [[ stone_block._focus_found = true; ]]
        },
        {
            tag = 'circle',
            false,
            [[Что такое защитный круг второго порядка?
            ]],
            [[– Ульрих взмахивает рукой и в воздухе возникает светящийся
            символ. Вот это он. Не беспокойся – когда придёт время нарисовать
            его, ты вспомнишь символ до мельчайшей детали.
            ]],
            code = [[ take (circle_of_defence_sign); ]]
        },
        {
            tag = 'herbs',
            false,
            always = true,
            [[Где найти багульник и паслён?
            ]],
            [[– Эти травы должны быть в лаборатории. На пузырьке с багульником
            будет написано «Ledum palustre», а с паслёном – «Solarium nigrum».
            ]],
            code = [[ cupboard._herbs_know = true; ]]
        },
        {
            tag = 'storage',
            false,
            always = true,
            [[Что такое предмет-накопитель?
            ]],
            [[– Такой предмет может накапливать в себе энергию, а потом
            отдавать её в нужный момент. Накопивший энергию предмет можно
            разрушить только если полностью нейтрализовать магию. Если этого
            не сделать, произойдёт выброс накопленной энергии с
            непредсказуемыми последствиями.
            ]],
            code = [[ pon ('storage_destruct'); if have (statuette) then p 'Ты уже взял стеклянную статуэтку – это и есть один из таких предметов.'; else p 'На верхней полке этажерки ты найдёшь стеклянную статуэтку – это один из таких предметов.'; end ]]
        },
        {
            tag = 'storage_desctruct',
            false,
            always = true,
            [[Как уничтожить предмет-накопитель?
            ]],
            [[– Это слишком сложный процесс. Если ты хоть немного ошибёшься,
            проклятие снять не получится. Лучше принести накопитель мне.
            ]]
        },
        {
            tag = 'demon',
            false,
            always = true,
            [[Как ослабить демона?
            ]],
            [[– Демон, находящийся в нашем мире, уже ослаблен. Но он может
            подпитываться сильными страстями и эмоциями. Людей, от которых
            демон получает силу, маги называют Опорами. Если тебе удастся
            понять, почему человек стал Опорой, и разрешить эту проблему, то
            Опора будет разрушена и демон ослаблен.
            ]],
        },
        {
            always = true,
            [[Назад.]],
            code = [[ back (); ]]
        };
    },
};


statuette = obj
{
    nam = 'статуэтка',
    _ritual_location = '',
    _force = false;
    dsc = function (s)
        if here () == mages_hall_cabinet then
            p [[На верхней полке этажерки стоит небольшая стеклянная
            {статуэтка}.
            ]];
        end
        if here () == laboratory_ritual_chamber then
            if s._ritual_location == 'block' then
                p 'На блоке стоит стеклянная {статуэтка}.';
            end
            if s._ritual_location == 'circle' then
                p 'В защитном круге стоит стеклянная {статуэтка}.';
            end
            if s._ritual_location == 'pentagram' then
                p 'В центре пентаграммы стоит стеклянная {статуэтка}.';
            end
        end
    end,
    tak = function (s)
        if here () == laboratory_ritual_chamber then
            if not ritual_finished and seen (candles) then
                ritual_error = true;
            end
        end
        p 'Ты берёшь стеклянную статуэтку.';
    end,
    inv = function (s)
        p [[Стеклянная статуэтка с ладонь величиной в виде человечка,
        танцующего внутри вихрем закручивающейся спирали.
        ]];
        if ritual_finished then
            p 'В центре статуэтки горит багровый огонёк.';
            if s._force then
                p 'Статуэтка слегка вибрирует в руках. Она наполнена силой.';
            end
        end
    end,
    use = function (s, w)
        if w == stone_block then
            s._ritual_location = 'block';
            ritual_error = true;
            drop (s);
            p 'Ты устанавливаешь статуэтку на каменный блок.';
        end
        if w == circle_of_defence then
            s._ritual_location = 'circle';
            ritual_error = true;
            drop (s);
            p 'Ты устанавливаешь статуэтку в защитный круг.';
        end
        if w == pentagram then
            s._ritual_location = 'pentagram';
            if candles._burning then
                ritual_error = true;
            end
            drop (s);
            p 'Ты устанавливаешь статуэтку в центр пентаграммы.';
        end
        if w == magician and ritual_finished then
            p [[Ульрих что-то шепчет на статуэткой и вдруг его фигура начинает
            становиться всё более материальной.^
            – Жалкий дурак! Это я вызвал демона! Но тогда завершить ритуал у
            меня не получилось – мой наставник что-то почувствовал и смог
            частично блокировать демона. Это ударило и по мне, как по
            вызывающему, и я начал терять силы. Всё что я успел – это написать
            письмо в надежде что какой-нибудь дурень поможет мне завершить
            начатое. А теперь умри!^
            Тебя охватывает чёрное пламя. Перед тем, как потерять сознание, ты
            несколько мгновений испытываешь ужасную боль.
            ]];
            walk (death);
        end
    end,
};


stick = obj
{
    nam = function (s)
        if s._light == 0 then
            return ('палочка');
        else
            return ('палочка (*)');
        end
    end,
    _light = 0,
    dsc = function (s)
        if seen (statuette) then
            p [[Возле статуэтки лежит круглая деревянная {палочка}.
            ]];
        else
            p [[На верхней полке этажерки лежит круглая деревянная {палочка}.
            ]];
        end
    end,
    tak = function (s)
        p 'Ты берёшь палочку.';
    end,
    inv = function (s)
        take (spell_ardere);
        p [[Деревянная палочка. Круглая деревянная палочка длиной с ладонь.
        Сбоку на ней вырезано слово «Ardere».
        ]];
        if s._light > 0 then
            p 'На конце палочки горит небольшой огонёк.';
        end
    end,
    life = function (s)
        s._light = s._light - 1;
        if s._light == 2 then
            p [[Как только ты произносишь «Ardere», на кончике палочки
            загорается небольшой огонёк.
            ]];
        end
        if s._light == 1 then
            p [[Огонёк на конце палочки тускнеет.
            ]];
        end
        if s._light == 0 then
            lifeoff (s);
            p [[Огонёк на конце палочки гаснет.
            ]];
        end
    end,
    use = function (s, o)
        if o == candle and s._light > 0 then
            if here ()== church_altar and candle._burning then
                p 'Свеча уже горит.';
            else
                candle._burning = true;
                altar._moved = true;
                ways (curch_altar):add (vroom ('Спуститься в проём', 'church_basement'));
                p [[Как только ты зажигаешь свечу, алтарь с тихим шорохом
                отодвигается, открывая проём в полу с каменными ступенями,
                ведущими во тьму.
                ]];
            end
        end
        if o == leaves and s._light > 0 then
            if leaves._burning then
                p 'Листья уже тлеют.';
            else
                leaves._burning = true;
                p 'Ты поджигаешь сухие листья в фонтане.';
                bowl:melt ();
            end
        end
        if o == candles then
            if have (candles) then
                p 'Тебе нужно найти место куда поставить свечи.';
            else
                if here () == laboratory_ritual_chamber and s._light > 0 then
                    if candles._burning then
                        p 'Свечи уже зажжены.';
                    else
                        candles._burning = true;
                        if not seen (statuette) then
                            ritual_error = true;
                        end
                        p 'Ты зажигаешь свечи.';
                    end
                end
            end
        end
    end,
};


church_basement = room
{
    nam = 'Церковь. Подвал.',
    dsc = function (s)
        p [[Узкая каменная лестница ведёт в сырой подвал, который размерами не
        уступает самой церкви. Капли воды медленно стекают по каменным
        колоннам, которые поддерживают потолок, и неожиданно, ты слышишь среди
        звука падающих капель тихие стоны, которые раздаются из тёмных углов
        подвала. Даже воздух здесь пахнет плесенью и разложением, а тонкий
        слой воды на полу заставляет пристально смотреть, куда именно ставишь
        ногу.
        ]];
    end,
    obj =
    {
        'doll_rag'
    },
    way =
    {
        vroom ('Наверх', 'church_altar'),
    },
    exit = function (s, to)
        if to == church_altar and doll_rag._time > 0 then
            p [[Ты пытаешься сдвинуть алтарь, но он слишком тяжёлый.
            ]];
            return false;
        end
    end,
};


doll_rag = obj
{
    nam = 'тряпичная кукла',
    _time = 0,
    dsc = function (s)
        p [[В самом центре комнаты, окружённая тенями, лежит небольшая
        {тряпичная кукла}.
        ]];
    end,
    tak = function (s)
        lifeon (s);
        p [[Как только ты поднимаешь куклу, тьма в подвале сгущается. Алтарь
        со скрежетом закрывает проход.
        ]];
    end,
    inv = function (s)
        if s._time > 0 then
            s._time = 0;
            drop (s);
            p 'Ты кладёшь куклу на место.';
            lifeoff (s);
        else
            p [[Кукла сделана из разноцветных кусочков ткани, намотанных на
            твёрдую основу. Не отличается особой красотой, но видно, что
            сделана она была с любовью.
            ]];
        end
    end,
    life = function (s)
        s._time = s._time + 1;
        if s._time == 1 then
            p [[Из ниоткуда раздаётся странный голос, эхом отражаясь от стен:
            «Верни куклу!»
            ]];
        end
        if s._time == 2 then
            p [[«Верни куклу!» – ужасный голос опять нарушает тишину.
            ]];
        end
        if s._time == 3 then
            lifeoff (s);
            walk (death);
            p [[Дьявольский хохот заполняет подвал: «Твоя душа теперь
            принадлежит мне! Добро пожаловать в АД!»
            ]];
        end
    end,
    use = function (s, o)
        if o == girl then
            girl._dispelled = true;
            girl:disable();
            p [[«Мари!» – вскрикивает девочка с радостью. Всё её тело начинает
            светиться, и с лёгким хлопком она исчезает.
            ]];
        end
    end,
};


spell_ardere = obj
{
    nam = '«Ardere»',
    inv = function (s)
        stick._light = 3;
        lifeon (stick);
        return true;
    end,
    tak = function (s)
        return true;
    end,
};


death = room
{
    nam = 'Смерть',
    hideinv = true,
    pic = 'images/death.png',
    enter = function (s, from)
        set_music ('music/death.ogg', 1);
    end,
};


victory = room
{
    nam = 'Победа',
    hideinv = true,
    forcedsc = true,
    enter = function (s, from)
        set_music ('music/win.ogg');
    end,
    dsc = function (s)
        p [[Как только капля касается поверхности статуэтки, она рассыпается в
        мелкую пыль.^
        Когда ты выходишь из здания, ты понимаешь, что туман исчез. Тебе
        удалось снять проклятие!
        ]];
    end,
};


spell_entero_vidis = obj
{
    nam = '«Entero Vidis»',
    inv = function (s)
        if here () == mages_tower_front then
            if mages_tower_front._can_enter_tower then
                p [[Путь в башню магов уже открыт.
                ]];
                return;
            else
                mages_tower_front._can_enter_tower = true;
                p [[Ты произносишь «Entero Vidis» и чувствуешь, как невидимая
                стена изменяется. Теперь ты можешь войти в северную башню.
                ]];
                return;
            end
        end
        p [[Ты произносишь «Entero Vidis». Ничего не происходит.
        ]];
    end,
};


laboratory_front = room
{
    nam = 'Перед лабораторией',
    dsc = function (s)
        p [[Приземистое здание практически неразличимо в густом тумане. В
        нескольких шагах от входной двери виден колодец.
        ]];
    end,
    way =
    {
        vroom ('В лабораторию', 'laboratory'),
        vroom ('К колодцу', 'well'),
        vroom ('Площадь', 'city_square'),
    },
};


well = room
{
    nam = 'Колодец',
    _seen = false,
    enter = function (s, from)
        if not s._seen then
            s._seen = true;
            magician_dlg:pon ('well_water');
        end
    end,
    dsc = function (s)
        p [[Колодец выглядит очень старым; несколько камней из его кладки были
        давно утеряны. Но всё же, он не кажется хрупким или готовым
        разрушиться: камень, из которого он сложен, крепок, как сталь, и
        холоден, как лёд.
        ]];
    end,
    obj =
    {
        'well_water',
    },
    way =
    {
        vroom ('К лаборатории', 'laboratory_front'),
    },
};


well_water = obj
{
    nam = 'вода',
    dsc = function (s)
        p [[{Вода} в колодце тёмная и гладкая.
        ]];
    end,
    act = function (s)
        walk (well_water_dlg);
    end,
};


well_water_dlg = dlg
{
    nam = 'Колодец',
    hideinv = true,
    dsc = function (s)
        p [[Какое-то странное ощущение исходит от этого овального чёрного
        водоёма: как будто бы некое исполинское животное, нашло небольшую
        замочную скважину в своей тюрьме и смотрит одним глазом на то, что
        происходит за её стенами.
        ]];
    end,
    phr =
    {
        {
            always = true,
            [[Осмотреть воду.]],
            [[Чёрная и гладкая как стекло вода ничего не отражает в своих
            глубинах.
            ]]
        };
        {
            always = true,
            [[Коснуться воды.]],
            [[Ты чувствуешь, как вода вытягивает из тебя силы. Колени
            подкашиваются и ты падаешь в колодец.
            ]],
            code = [[ walk (death); ]]
        };
        {
            always = true,
            [[Назад.]],
            [[Ты отходишь от колодца.]],
            code = [[ back (); ]]
        };
    },
};


laboratory = room
{
    nam = 'Лаборатория',
    dsc = function (s)
        p [[Большая квадратная комната, уставленная столами, тумбочками,
        полками, шкафами. Справа от двери  — стол, на нем – раскрытая книга.
        Рядом — чуть отодвинутое кресло. Все выглядит так, как если бы хозяин
        минуту назад встал из-за стола. Книга раскрыта на описании неких
        нюансов создания магических предметов.^
        На столах и полках — разнообразное лабораторное оборудование.
        ]];
    end,
    obj =
    {
        'retorts',
        'cupboard',
    },
    way =
    {
        vroom ('Идти через арку', 'laboratory_ritual_chamber'),
        vroom ('Выйти из лаборатории', 'laboratory_front'),
    },
};


retorts = obj
{
    nam = 'колбы',
    _number = 3,
    dsc = function (s)
        if s._number > 0 then
            p [[Почти всё оно разбито, уцелели только несколько разноцветных
            {колб}.
            ]];
        else
            p 'Всё оборудование разбито.';
        end
    end,
    act = function (s)
        if s._number == 1 then
            s._number = 0;
            take (retort_red);
            p 'Ты берёшь красную колбу.';
        end
        if s._number == 2 then
            s._number = 1;
            take (retort_green);
            p 'Ты берёшь зелёную колбу.';
        end
        if s._number == 3 then
            s._number = 2;
            take (retort_blue);
            p 'Ты берёшь синюю колбу.';
        end
    end,
};


retort_blue = obj
{
    nam = 'синяя колба',
    inv = function (s)
        p 'Небольшая колба из синего стекла.';
    end,
    use = function (s, o)
        if o == well_water then
            p [[Ты осторожно набираешь воду в колбу, но вдруг она лопается, и
            брызги попадают на кожу. Каждая капелька обжигает, как будто это
            не вода, а раскалённый металл. Ты чувствуешь как силы покидают
            тебя. Пошатнувшись, ты падаешь в колодец.
            ]];
            walk (death);
        end
    end,
};


retort_green = obj
{
    nam = 'зелёная колба',
    inv = function (s)
        p 'Небольшая колба из зелёного стекла.';
    end,
    use = function (s, o)
        if o == well_water then
            p [[Ты осторожно набираешь воду в колбу, но вдруг она лопается, и
            брызги попадают на кожу. Каждая капелька обжигает, как будто это
            не вода, а раскалённый металл. Ты чувствуешь как силы покидают
            тебя. Пошатнувшись, ты падаешь в колодец.
            ]];
            walk (death);
        end
    end,
};


retort_red = obj
{
    nam = 'красная колба',
    _know = false,
    _filled = false,
    inv = function (s)
        if not s._filled then
            p 'Небольшая колба из красного стекла.';
        else
            p [[Небольшая колба из красного стекла, наполненная чёрной водой
            из колодца возле лаборатории.
            ]];
        end
        if s._know then
            p [[Ульрих сказал, что такая вода – сильнейший нейтрализатор
            магии.
            ]];
        end
    end,
    use = function (s, o)
        if o == well_water then
            if s._filled then
                p 'Колба уже наполнена водой.';
                return;
            else
                s._filled = true;
                p 'Ты осторожно набираешь воду в колбу.';
                return;
            end
        end
        if not s._know then
            p 'Зачем? В этом нет никакого смысла.';
            return;
        else
            if o == chamber_pentagram then
                p [[В комнате раздаётся ужасный хохот.^
                – Ты освободил меня, смертный. И за это я подарю тебе вечность
                боли!^
                Каждая клеточка твоего тела начинает гореть как в огне. Кожа
                покрывается кровавым потом. Через несколько мгновений ты
                теряешь сознание.
                ]];
                walk (death);
            end
            if o == cube then
                if not cube._whole then
                    p 'Куб уже разрушен.';
                    return;
                else
                    cube._whole = false;
                    p [[Ты аккуратно капаешь на куб водой из красной колбы. С
                    тихим звоном кристаллический куб разлетается на осколки.
                    ]];
                    return;
                end
            end
            if o == dreamer then
                lifeoff (dreamer);
                dreamer._awake = true;
                dreamer:disable();
                p [[Как только капля воды касается спящего, он тут же
                просыпается и садится на кровати. «Как же долго я спал!» –
                произносит он. Тело мужчины становится всё более прозрачным и
                исчезает.
                ]];
                return;
            end
            if o == mansion_hall_paintings then
                if mansion_hall_paintings._dispelled then
                    p 'Картины уже очищены.';
                    return;
                else
                    mansion_hall_paintings._dispelled = true;
                    p [[Как только капля касается холста, по картинам проходит
                    волна искажений, и сюжет их меняется.
                    ]];
                    artist:check_dispelled ();
                    return;
                end
            end
            if o == mansion_reception_hall_paintings then
                if mansion_reception_hall_paintings._dispelled then
                    p 'Картины уже очищены.';
                    return;
                else
                    mansion_reception_hall_paintings._dispelled = true;
                    p [[Как только капля касается холста, по картинам проходит
                    волна искажений, и сюжет их меняется.
                    ]];
                    artist:check_dispelled ();
                    return;
                end
            end
            if o == mansion_bedroom_paintings then
                if mansion_bedroom_paintings._dispelled then
                    p 'Картины уже очищены.';
                    return;
                else
                    mansion_bedroom_paintings._dispelled = true;
                    p [[Как только капля касается холста, по картинам проходит
                    волна искажений, и сюжет их меняется.
                    ]];
                    artist:check_dispelled ();
                    return;
                end
            end
            if o == statuette and ritual_finished then
                if statuette._force then
                    p [[Как только капля касается поверхности статуэтки, она
                    рассыпается в мелкую пыль. Багровый огонёк, заключённый
                    внутри статуэтки, начинает расти и спустя мгновение
                    поглощает тебя.^
                    Ты кричишь от боли, но твой крик никто не слышит.
                    ]];
                    walk (death);
                else
                    walk (victory);
                end
            end
        end
    end,
};


cupboard = obj
{
    nam = 'шкафы',
    _candles_maker_kit = true,
    _herbs_know = false,
    _labrador_tea = true,
    _nightshade = true,
    dsc = function (s)
        p [[{Шкафы} заставлены различными пузырьками с непонятными подписями.^
        Небольшая арка ведёт в соседнюю комнату.
        ]];
    end,
    act = function (s)
        if s._candles_maker_kit then
            s._candles_maker_kit = false;
            take (candles_form);
            take (bowl);
            p [[В одном из шкафов ты находишь металлическую миску и форму для
            выплавки свечей.
            ]];
            return;
        end
        if s._herbs_know and (s._labrador_tea or s._nightshade) then
            if s._labrador_tea then
                s._labrador_tea = false;
                take (labrador_tea);
                p [[Ты берёшь пузырёк с надписью «Ledum palustre».
                ]];
                return;
            end
            if s._nightshade then
                s._nightshade = false;
                take (nightshade);
                p [[Ты берёшь пузырёк с надписью «Solarium nigrum».
                ]];
                return;
            end
        else
            p [[Надписи на пузырьках тебе ни о чём не говорят.
            ]];
        end
    end,
};


candles_form = obj
{
    nam = 'форма для свечей',
    inv = function (s)
        p [[Форма, позволяющая отливать свечи.
        ]];
    end,
    use = function (s, o)
        if o == bowl and seen (bowl) then
            if bowl._wax then
                bowl._wax = false;
                if bowl._labrador_tea then
                    bowl._labrador_tea = false;
                    candles._labrador_tea = true;
                end
                if bowl._nightshade then
                    bowl._nightshade = false;
                    candles._nightshade = true;
                end
                take (candles);
                candles:enable();
                p 'Ты отливаешь свечи.';
            end
        end
    end,
};


bowl = obj
{
    nam = 'миска',
    _candles = false,
    _wax = false,
    _labrador_tea = false,
    _nightshade = false,
    inv = function (s)
        p [[Глубокая металлическая миска. Судя по всему, когда-то в ней
        плавили воск.
        ]];
    end,
    dsc = function (s)
        p [[стоит металлическая {миска}.
        ]];
    end,
    act = function (s)
        if s._candles or s._wax or s._labrador_tea or s._nightshade then
            p 'В миске ты видишь:^';
            if s._candles then
                p '– свечи^';
            end
            if s._wax then
                p '– воск^';
            end
            if s._labrador_tea then
                p '– багульник болотный^';
            end
            if s._nightshade then
                p '– паслён чёрный';
            end
        else
            p 'Металлическая миска пуста.';
        end
    end,
    use = function (s, o)
        if o == fountain then
            drop (s);
            p [[Ты ставишь миску в фонтан.
            ]];
        end
    end,
    melt = function (s)
        if leaves._burning and s._candles then
            s._candles = false;
            s._wax = true;
            if candles._labrador_tea then
                s._labrador_tea = true;
            end
            if candles._nightshade then
                s._nightshade = true;
            end
            p [[Свечи в миске расплавились, превратившись в воск.
            ]];
        end
    end,
};


labrador_tea = obj
{
    nam = 'багульник',
    inv = function (s)
        p [[Пузырёк с сушёным болотным багульником. Надпись на пузырьке гласит
        «Ledum palustre».
        ]];
    end,
    use = function (s, w)
        if w == bowl then
            if have (bowl) then
                p 'Тебе нужно найти подходящее место для миски.';
            else
                drop (s);
                s:disable();
                bowl._labrador_tea = true;
                p [[Ты высыпаешь сушёный болотный багульник в миску.
                ]];
            end
        end
    end,
};


nightshade = obj
{
    nam = 'паслён',
    inv = function (s)
        p [[Пузырёк с сушёными листьями чёрного паслёна. Надпись на пузырьке
        гласит «Solarium nigrum».
        ]];
    end,
    use = function (s, w)
        if w == bowl then
            if have (bowl) then
                p 'Тебе нужно найти подходящее место для миски.';
            else
                drop (s);
                s:disable();
                bowl._nightshade = true;
                p [[Ты высыпаешь сушёные листья чёрного паслёна в миску.
                ]];
            end
        end
    end,
};


circle_of_defence_sign = obj
{
    nam = 'защитный круг',
    inv = function (s)
        walk (circle_of_defence_sign_read);
    end,
    use = function (s, w)
        if w == stone_block and stone_block._focus_found then
            circle_of_defence:enable();
            drop (s);
            if seen (pentagram) then
                ritual_error = true;
            end
            p 'Ты рисуешь защитный круг второго порядка на блоке.';
        end
        if w == pentagram then
            circle_of_defence:enable();
            drop (s);
            ritual_error = true;
            p 'Ты рисуешь защитный круг второго порядка.';
        end
    end,
};


circle_of_defence_sign_read = room
{
    nam = 'Защитный круг второго порядка',
    hideinv = true,
    pic = 'images/circle.png',
    dsc = function (s)
        p [[Светящийся символ – защитный круг второго порядка.
        ]];
    end,
    obj =
    {
        vway('1', '{Назад}', 'mages_tower_book_room'),
    },
    exit = function (s, to)
        back ();
    end,
};


laboratory_ritual_chamber = room
{
    nam = 'Комната ритуалов',
    dsc = function (s)
        p [[Небольшая квадратная комната, стены которой испещрены защитными
        рунами и узорами. Узкий проход в дальней стене ведёт в комнату
        призывов.
        ]];
    end,
    obj =
    {
        'stone_block',
        'chalk',
    },
    way =
    {
        vroom ('В лабораторию', 'laboratory'),
        vroom ('Комната призывов', 'laboratory_summoning_chamber'),
    },
};


stone_block = obj
{
    nam = 'блок',
    _focus_found = false,
    dsc = function (s)
        p [[Комната практически пуста. Посредине комнаты стоит
        ]];
        if ritual_finished then
            p 'оплавленный'
        end
        p [[монолитный каменный {блок} высотой чуть больше метра.
        ]];
    end,
    act = function (s)
        if seen (chalk) then
            take (chalk);
            p 'На блоке ты находишь небольшой мелок.';
            return;
        end
        p 'Монолитный каменный блок.';
    end,
    obj =
    {
        'circle_of_defence',
        'pentagram',
    },
};


chalk = obj
{
    nam = 'мелок',
    inv = 'Небольшой кусочек мела.',
    use = function (s, w)
        if w == stone_block and stone_block._focus_found then
            if not seen (pentagram) then
                ritual_error = true;
                p 'Ты рисуешь пентаграмму мелом на блоке.';
            end
        end
        if w == circle_of_defence and stone_block._focus_found then
            if not seen (pentagram) then
                pentagram:enable();
                if not seen (circle_of_defence) then
                    ritual_error = true;
                end
                p 'Ты вписываешь мелом пентаграмму в круг.';
            end
        end
    end,
};


circle_of_defence = obj
{
    nam = 'круг',
    dsc = function (s)
        p [[На поверхности блока нарисован защитный {круг} второго порядка.
        ]];
    end,
    act = function (s)
        p [[Защитный круг второго порядка нарисован на блоке.
        ]];
    end,
}:disable();


pentagram = obj
{
    nam = 'пентаграмма',
    dsc = function (s)
        if seen (circle_of_defence) then
            p [[В круг вписана {пентаграмма}.
            ]];
        else
            p [[На поверхности блока нарисована {пентаграмма}.
            ]];
        end
    end,
    act = function (s)
        p [[Пентаграмма, нарисованная мелом на каменном блоке.
        ]];
    end,
}:disable();



laboratory_summoning_chamber = room
{
    nam = 'Комната призывов',
    dsc = function (s)
        p [[Стены комнаты сделаны из необтёсанных блоков тёмно-красного камня.
        ]];
    end,
    obj =
    {
        'chamber_pentagram',
    },
    way =
    {
        vroom ('Комната ритуалов', 'laboratory_ritual_chamber'),
    },
};


chamber_pentagram = obj
{
    nam = 'пентаграмма',
    dsc = function (s)
        p [[На полу, занимая почти всю площадь комнаты — {пентаграмма} вызова,
        окружённая защитным кругом. Внутри круга в каменном полу видны
        глубокие борозды, процарапанные огромными когтями какого-то ужасного
        существа.
        ]];
    end,
    act = function (s)
        p [[Пентаграмма занимает почти всю комнату. И хотя в ней никого нет,
        тебя не оставляет ощущение, что кто-то наблюдает за тобой.
        ]];
    end,
};

